<?php

/*******************************************************************************
/*******************************************************************************
    doorGets 6.0 - 20, February 2014
    doorgets it's free PHP Open Source CMS PHP & MySQL
    Copyright (C) 2012 - 2014 By Mounir R'Quiba -> Crazy PHP Lover
    
/*******************************************************************************

    Website : http://www.doorgets.com
    Contact : http://www.doorgets.com/?contact
    
/*******************************************************************************
    -= One life, One code =-
/*******************************************************************************
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
******************************************************************************
******************************************************************************/


class SendMailAlert extends Langue{
    
    public $header;

    public $email;

    public $sujet;

    public $messageHtml;

    public $messageTxt;

    public function __construct($email,$sujet,$lg= 'fr',$content=""){
        
        parent::__construct($lg);
        
    	$this->email = $email;
    	$this->sujet = $sujet;

    	$msHtml = '<br /><br /><b>'.$this->l('Connexion').' :</b> <br />';
    	$msHtml .= '<ul><li><a href="'.URL.'dg-admin/">'.URL.'dg-admin/</a></li></ul>';
    	$msHtml .= '<br />------------------------------------';
	$msHtml .= '<br />------------------------------------';
	if(!empty($content)){
	    $msHtml .= $content;
	    $msHtml .= '<br /> <br />------------------------------------';
	    $msHtml .= '----------------------------------------------------------------------<br /><br />';
	    $msHtml .= '----------------------------------------------------------------------<br /><br />';
	}
	
    	$msTxt = '\r\n';
    	$msTxt .= ''.$this->l('Connexion').' : ';
    	$msTxt .= URL.'dg-admin/';
    	$msTxt .= '\r\n';
    	$msTxt .= '\r\n';
	if(!empty($content)){
	    $msTxt .= '----------------------------------------------------------------------';
	    $msTxt .= $content;
	    $msTxt .= '----------------------------------------------------------------------';
	    $msTxt .= '\r\n';
	    $msTxt .= '----------------------------------------------------------------------';	    
	}


    	$this->messageHtml = "<html><head></head><body>";
    	$this->messageHtml .= $msHtml;
    	$this->messageHtml .= "</body></html>";

    	$this->messageTxt = $msTxt;
    	
    	$this->sendMail();

    }

    private function sendMail(){

    	$serverName = $_SERVER['SERVER_NAME'];
    	$serverName = str_replace('www.', '', $serverName);
    	$mailSender = 'no-reply@'.$serverName;

    	$boundary = "-----=".md5(rand());

    	if (!preg_match("#^[a-z0-9._-]+@(hotmail|live|msn).[a-z]{2,4}$#", $this->email)) 
		{ $pl= "\r\n"; }else{ $pl = "\n"; }

		$this->header = "From: \"$serverName\"<$mailSender>".$pl;
		$this->header.= "Reply-to: \"$serverName\" <$mailSender>".$pl;
		$this->header.= "MIME-Version: 1.0".$pl;
		$this->header.= "Content-Type: multipart/alternative;".$pl." boundary=\"$boundary\"".$pl;

		$message = $pl."--".$boundary.$pl;
		//=====Ajout du message au format texte.
		$message.= "Content-Type: text/plain; charset=\"ISO-8859-1\"".$pl;
		$message.= "Content-Transfer-Encoding: 8bit".$pl;
		$message.= $pl.$this->messageTxt.$pl;
		//==========
		$message.= $pl."--".$boundary.$pl;
		//=====Ajout du message au format HTML
		$message.= "Content-Type: text/html; charset=\"ISO-8859-1\"".$pl;
		$message.= "Content-Transfer-Encoding: 8bit".$pl;
		$message.= $pl.$this->messageHtml.$pl;
		//==========
		$message.= $pl."--".$boundary."--".$pl;
		$message.= $pl."--".$boundary."--".$pl;

		@mail($this->email,$this->sujet,$message,$this->header);

    }
    
}